import { useCallback, useEffect } from 'react';
import { useAppDispatch, useAppSelector } from '../../hooks';

import {
  AuthType,
  FilterDataType,
  HandleFormDataChangeType,
  HandleNavigateType,
  HandleSearchResetType,
  HandleSearchTriggerType,
  HandleSearchType,
  HandleToggleType,
  ToggleType,
  WithHocAuth,
  WithHocForm,
  WithHocNavigate,
  WithHocSearch,
  WithHocToggle,
} from '../../hoc';

import logo from '../../assets/img/logo.svg';
import sdwLogo from '../../assets/img/logo.png';
import './App.scss';

export const App = ({
  auth,
  handleFormDataChange,
  toggle,
  handleToggle,
  handleSearch,
  handleSearchTrigger,
  handleSearchReset,
  filterData,
  handleNavigate,
}: {
  auth: AuthType; // WithHocAuth
  handleFormDataChange: HandleFormDataChangeType; // WithHocForm
  toggle: ToggleType; // WithHocToggle
  handleToggle: HandleToggleType; // WithHocToggle
  handleSearch: HandleSearchType; // WithHocSearch
  handleSearchTrigger: HandleSearchTriggerType; // WithHocSearch
  handleSearchReset: HandleSearchResetType; // WithHocSearch
  filterData: FilterDataType; // WithHocSearch
  handleNavigate: HandleNavigateType; // WithHocNavigate
}) => {
  const dispatch = useAppDispatch();

  return (
    <header className='App-header'>
      <div className='cont'>
        <img
          src={sdwLogo}
          className='sdw-logo d-block mg-auto'
          alt='SDW logo'
        />

        <img src={logo} className='App-logo' alt='logo' />
        <p>Edit <code>src/App.tsx</code> and save to reload.</p>

        <a
          className='App-link'
          href='https://reactjs.org'
          target='_blank'
          rel='noopener noreferrer'
        >
          Learn React
        </a>
      </div>
    </header>
  );
};

export const AppWithHoc = WithHocAuth(
  WithHocForm(
    WithHocToggle(
      WithHocSearch(
        WithHocNavigate(App)
      )
    )
  )
);
